#!/usr/bin/python2.7
# -*- coding: utf-8 -*-

import os, shutil, sys
import subprocess

if len (sys.argv) != 2:
    sys.exit (1)

mtabFile = '/etc/mtab'
rootFmasDir = '/srv/FMAS'
rootProgramsDir  = os.path.join (rootFmasDir, 'programas')

programName = sys.argv [1]

def getMountPoint ():
    p = subprocess.Popen ('df -h', stdout=subprocess.PIPE, stderr=subprocess.PIPE, shell=True)

    (output, err) = p.communicate ()
    p_status = p.wait ()

    for l in output.split('\n'):
        if '/dev/sd' in l.split (' ')[0]:
            return l.split (' ')[0]

def getUsbPath ():
    mountPoint = getMountPoint ()

    f = open (mtabFile, 'r')
    for l in f:
        if mountPoint in l:
            if not os.path.exists (os.path.join (l.split (' ') [1], 'FMAS')):
                os.mkdir (os.path.join (l.split (' ') [1], 'FMAS'))

            f.close ()
            return str (os.path.join (l.split (' ') [1], 'FMAS'))

    f.close ()
    return None

def copyProgram (usbPath ,programName):
    if not os.path.exists (os.path.join (usbPath, 'exports')):
        os.makedirs (os.path.join (usbPath, 'exports'))

    try:
        shutil.copytree (os.path.join (rootProgramsDir, programName), os.path.join (os.path.join (usbPath, 'exports'), programName))
    except OSError:
        shutil.rmtree (os.path.join (os.path.join (usbPath, 'exports'), programName))
        shutil.copytree (os.path.join (rootProgramsDir, programName), os.path.join (os.path.join (usbPath, 'exports'), programName))

usbPath = getUsbPath ()

if usbPath:
    try:
        copyProgram (usbPath, programName)
        print '1'
    except Exception as e:
        print '2'
else:
    print '0'
