#!/usr/bin/python2.7
# -*- coding: utf-8 -*-

import os, shutil

rootMediaDir = '/media/'

rootFmasDir = '/srv/FMAS'
rootProgramsDir  = os.path.join (rootFmasDir, 'programas')

def getUsbPath ():
    for dir in os.listdir (rootMediaDir):
        candidateMountedDir = os.path.join (rootMediaDir, dir)
        if (os.path.ismount (candidateMountedDir)):
            if os.path.exists (os.path.join (candidateMountedDir, 'FMAS')):
                return os.path.join (candidateMountedDir, 'FMAS')
    return None


def updateFirmware (usbPath):
    if os.path.exists (os.path.join (usbPath, 'L800.a')):
        if os.path.isfile (os.path.join (usbPath, 'L800.a')):
            print 'new firmware update found'
            if (os.path.exists (os.path.join (usbPath, 'init.sh'))):
                print 'new init script found, executing'
                os.system ('bash ' + os.path.join (usbPath, 'init.sh'))
            else:
                print 'no init script found'

            try:
                print 'updating firmware'
                shutil.copyfile ((os.path.join (usbPath, 'L800.a')), (os.path.join (rootFmasDir, 'L800.a')))
                os.chmod ((os.path.join (rootFmasDir, 'L800.a')), 755)
            except Exception as e:
                print 'error updating the firmware'
    else:
        print 'new firmware not found'

def prepareMplayer ():
    os.environ ['VDPAU_DRIVER'] = 'sunxi'

    try:    os.remove ('/tmp/mplayer-control')
    except: pass

    try:    os.mkfifo ('/tmp/mplayer-control')
    except:    pass

def getFolderSize (startPath):
    totalSize = 0
    for dirPath, dirNames, fileNames in os.walk(startPath):
        for f in fileNames:
            fp = os.path.join(dirPath, f)
            totalSize += os.path.getsize(fp)
    return totalSize

def getFreeSpace ():
    s = os.statvfs('.')
    return (s.f_bsize * s.f_bavail / 1.024)

def copyPrograms (usbPath):
    for dir in os.listdir (os.path.join (usbPath)):
        if os.path.isdir (os.path.join (usbPath, dir)) and dir != 'exports':
            if getFreeSpace () > getFolderSize (os.path.join (usbPath, dir)) + (200 * 1024 * 1024): # 200 * 1024 * 1024 -> 200 MB marge
                try:
                    print 'copying program \"' + dir + '\"'
                    shutil.copytree ((os.path.join (usbPath, dir)), os.path.join (rootProgramsDir, dir))
                except OSError:
                    shutil.rmtree (os.path.join (rootProgramsDir, dir))
                    shutil.copytree ((os.path.join (usbPath, dir)), os.path.join (rootProgramsDir, dir))
            else:
                print 'not enough free space to copy "' + str (dir) + '"'

def startProgram ():
    print os.system (os.path.join (rootFmasDir, 'L800.a'))

usbPath = getUsbPath ()

if usbPath:
    updateFirmware (usbPath)
    copyPrograms (usbPath)

prepareMplayer ()
startProgram ()
